#include <stdio.h>
#include <stdlib.h>

int main()
{
    int h,n;
    scanf("%d%d",&h,&n);
    int vodopad[h][n];
    int i,j,k;
    for(i=0;i<h;i++)
    {
        for(j=0;j<n;j++)
        {
            scanf("%d",&vodopad[i][j]);
        }
    }
    int linija[n];
    for(i=0;i<n;i++)
    {
        linija[i]=1;
    }
    for(i=0;i<h;i++)
    {
        if(vodopad[i][0]==0)
        {
            linija[1]+=linija[0];
            linija[0]=0;
        }
        if(vodopad[i][n-1]==0)
        {
            linija[n-2]+=linija[n-1];
            linija[n-1]=0;
        }
        for(j=1;j<n-1;j++)
        {
            if(vodopad[i][j]==0)
            {
                if(linija[j]%2==0)
                {
                    linija[j-1]+=linija[j]/2;
                    linija[j+1]+=linija[j]/2;
                    linija[j]=0;
                }
                else
                {
                    if(i%2==0)
                    {
                        linija[j-1]++;
                        linija[j]--;
                    }
                    else
                    {
                        linija[j+1]++;
                        linija[j]--;
                    }
                    linija[j-1]+=linija[j]/2;
                    linija[j+1]+=linija[j]/2;
                    linija[j]=0;
                }
            }
        }
    }
    for(i=0;i<n;i++)
    {
        printf("%d ",linija[i]);
    }
}